## js-of-ocaml 2.2

=== Makefile ===

all: no_examples examples
no_examples: build doc
build: check_lwt compiler compiler_lib library ocamlbuild runtime

include Makefile.conf
-include Makefile.local

.PHONY: all no_examples compiler library ocamlbuild runtime examples check_lwt doc build

compiler:
	$(MAKE) -C compiler
compiler_lib: compiler
	$(MAKE) -C compiler lib
library:
	$(MAKE) -C lib
ocamlbuild:
	$(MAKE) -C ocamlbuild
runtime:
	$(MAKE) -C runtime
toplevel: compiler compiler_lib library runtime
	$(MAKE) -C toplevel
examples: compiler library runtime
	$(MAKE) -C examples
tests: compiler library runtime
	$(MAKE) -C tests
phantomtests: compiler library runtime
	$(MAKE) -C tests phantom
doc: library ocamlbuild
	$(MAKE) -C doc

LWTERROR="Js_of_ocaml requires Lwt version 2.3.0 at least.  Please upgrade."
check_lwt:
	@if ocamlfind query lwt -l | ocaml tools/check_version.ml 2.3.0; then \
	  echo $(LWTERROR); exit 1; \
	fi

include Makefile.filelist

VERSION := $(shell head -n 1 VERSION)

install: install-lib install-bin

install-lib:
	ocamlfind install -patch-version ${VERSION} $(LIBRARY) lib/META $(INTF) $(IMPL) $(OTHERS) $(DOC) $(COMP_INTF) $(COMP_IMPL)

install-bin:
	install -d -m 755 $(BINDIR)
	install $(BIN) $(BINDIR)

uninstall: uninstall-lib uninstall-bin

uninstall-lib:
	ocamlfind remove $(LIBRARY)

uninstall-bin:
	rm -f $(BINDIR)/$(COMPILER)
	rm -f $(BINDIR)/$(MINIFIER)

reinstall: uninstall install

depend:
	$(MAKE) -C compiler depend
	$(MAKE) -C lib depend

clean:
	$(MAKE) -C compiler clean
	$(MAKE) -C lib clean
	$(MAKE) -C ocamlbuild clean
	$(MAKE) -C runtime clean
	$(MAKE) -C toplevel clean
	$(MAKE) -C examples clean
ifeq ($(wildcard tests),tests)
	$(MAKE) -C tests clean
	$(MAKE) -C doc clean
endif

realclean: clean
	find . -name "*~" -print | xargs rm -f
	find . -name "*.tmpjs" -print | xargs rm -f
	find . -name "#*" -print | xargs rm -f

dist:
	rm -rf /tmp/js_of_ocaml-${VERSION} &&\
        cd /tmp &&\
	git clone https://github.com/ocsigen/js_of_ocaml.git js_of_ocaml-${VERSION} &&\
	(cd js_of_ocaml-${VERSION}; git checkout ${VERSION}) &&\
	tar zcvf js_of_ocaml-${VERSION}.tar.gz js_of_ocaml-${VERSION} --exclude benchmarks --exclude .git --exclude tests

=== compiler/Makefile ===

include ../Makefile.conf

all: $(COMPILER) $(MINIFIER)

lib: compiler.cma compiler.cmxa compiler.cmxs

PACKAGES=findlib

OBJS=compiler_version.cmx \
     pretty_print.cmx util.cmx option.cmx reserved.cmx varPrinter.cmx \
     dgraph.cmx code.cmx javascript.cmx vlq64.cmx source_map.cmx \
     js_output.cmx js_simpl.cmx parse_info.cmx js_token.cmx js_parser.cmx \
     js_lexer.cmx parse_js.cmx annot_parser.cmx annot_lexer.cmx \
     instr.cmx primitive.cmx subst.cmx pure_fun.cmx deadcode.cmx \
     flow.cmx specialize.cmx specialize_js.cmx eval.cmx inline.cmx \
     tailcall.cmx freevars.cmx phisimpl.cmx \
     js_traverse.cmx js_assign.cmx js_tailcall.cmx \
     linker.cmx generate.cmx parse_bytecode.cmx driver.cmx \
     pseudoFs.cmx

COMPOBJS=$(OBJS) compile.cmx

$(COMPILER): compile.$(BEST)
	mv -f $< $@

$(MINIFIER): minify.$(BEST)
	mv -f $< $@

.INTERMEDIATE: compile.byte compile.opt minify.byte minify.opt

compile.byte: $(COMPOBJS:cmx=cmo)
	ocamlfind ocamlc -package $(PACKAGES) -linkpkg -o $@ $^
compile.opt: $(COMPOBJS)
	ocamlfind ocamlopt -package $(PACKAGES) -linkpkg -g -o $@ $^

minify.byte: $(OBJS:cmx=cmo) minify.cmo
	ocamlfind ocamlc -package $(PACKAGES) -linkpkg -o $@ $^
minify.opt: $(OBJS:cmx=cmx) minify.cmx
	ocamlfind ocamlopt -package $(PACKAGES) -linkpkg -g -o $@ $^


compiler.cma: $(OBJS:cmx=cmo)
	ocamlfind ocamlc -pack -o $@ $^

local/compiler.cma: compiler.cma
	mkdir -p local
	cp compiler.cma compiler.cmi local/

compiler.cmxa: $(OBJS)
	ocamlfind ocamlopt -pack -g -o $@ $^

compiler.cmxs: $(OBJS)
	ocamlfind ocamlopt -shared -g -o $@ $^

VERSION := $(shell head -n 1 ../VERSION)

compiler_version.ml: compiler_version.ml.tmp
	if cmp -s $^ $@; then rm $^; else mv $^ $@; fi

.PHONY: compiler_version.ml.tmp
compiler_version.ml.tmp:
	echo "let s = \"${VERSION}\"" > $@
	echo "let git_version = \"${VERSION_GIT}\"" >> $@

%.cmx: %.ml
	ocamlfind ocamlopt -package $(PACKAGES) -for-pack Compiler -g -c $<

%.cmo: %.ml
	ocamlfind ocamlc -package $(PACKAGES) -c $<

%.cmi: %.mli
	ocamlfind ocamlc -package $(PACKAGES) -c $<

%.ml %.mli: %.mly
	menhir --explain $<

js_parser.ml js_parser.mli: js_parser.mly
	menhir --external-tokens Js_token --explain $<

%.ml: %.mll
	ocamllex $<
clean:
	rm -f *.cm[aiox] *.cmxa *.cmxs *.o *.a *.conflicts
	rm -f compile.opt compile.byte minify.opt minify.byte
	rm -f $(MINIFIER) $(COMPILER)
	rm -f compiler_version.ml
	rm -f annot_lexer.ml annot_parser.ml annot_parser.mli
	rm -f js_lexer.ml js_parser.ml js_parser.mli

.PHONY: depend
depend: compiler_version.ml annot_lexer.ml js_lexer.ml js_parser.ml annot_parser.ml
	ocamldep *.ml *.mli > .depend

include .depend

=== doc/Makefile ===

include ../Makefile.conf
-include ../Makefile.local
include ../Makefile.filelist

MLIS := ${addprefix ../, ${DOC}}

ifneq "${WITH_GRAPHICS}" ""
OTHER=-package graphics -I ../lib/graphics
endif

.PHONY: doc docwiki
doc: api-html/index.html
api-html/index.html: ${MLIS} api-index
	mkdir -p api-html
	ocamlfind ocamldoc -package lwt -package ocamlbuild,deriving.syntax.common ${OTHER} -intro api-index -html \
	   -d api-html -I ../lib -I ../lib/deriving_json -I ../lib/syntax ${MLIS}


docwiki: api-wiki/index.wiki
api-wiki/index.wiki: ${MLIS} api-index
	mkdir -p api-wiki
	ocamlfind ocamldoc -package lwt -package ocamlbuild,deriving.syntax.common ${OTHER} -intro api-index \
	   -d api-wiki -I ../lib -I ../lib/deriving_json -I ../lib/syntax \
	   -i $(shell ocamlfind query wikidoc) -g odoc_wiki.cma \
	   ${MLIS}

EX_TOPLEVEL:=index.html toplevel.js toplevel-fs.js
EX_BOULDER:=index.html boulderdash.js sprites
EX_WEBGL:=index.html webgldemo.js
EX_GRAPH:=index.html jsviewer.js
EX_PLANET:=index.html texture.jpg planet.js
EX_WIKI:=index.html wiki.js
EX_WYSIWYG:=index.html wiki.js
EX_HYPER:=index.html hypertree.js icons
EX_MINE:=index.html minesweeper.js sprites
EX_CUBE:=index.html cubes.js

cp-examples:
	cp -R ${addprefix ../toplevel/, ${EX_TOPLEVEL}} manual-aux/toplevel/
	cp -R ${addprefix ../examples/boulderdash/, ${EX_BOULDER}} manual-aux/boulderdash/
	cp -R ${addprefix ../examples/webgl/, ${EX_WEBGL}} manual-aux/webgl/
	cp -R ${addprefix ../examples/graph_viewer/, ${EX_GRAPH}} manual-aux/graph_viewer/
	cp -R ${addprefix ../examples/planet/, ${EX_PLANET}} manual-aux/planet/
	cp -R ${addprefix ../examples/wiki/, ${EX_WIKI}} manual-aux/wiki/
	cp -R ${addprefix ../examples/wysiwyg/, ${EX_WYSIWYG}} manual-aux/wysiwyg/
	cp -R ${addprefix ../examples/minesweeper/, ${EX_MINE}} manual-aux/minesweeper/
	cp -R ${addprefix ../examples/cubes/, ${EX_CUBE}} manual-aux/cubes/
	cp -R ${addprefix ../examples/hyperbolic/, ${EX_HYPER}} manual-aux/hyperbolic/

clean:
	-rm -rf api-html/* api-wiki/*

=== lib/Makefile ===
MLOBJS= js.cmo dom.cmo typed_array.cmo dom_html.cmo file.cmo dom_events.cmo firebug.cmo lwt_js.cmo sys_js.cmo regexp.cmo cSS.cmo url.cmo form.cmo xmlHttpRequest.cmo event_arrows.cmo lwt_js_events.cmo json.cmo webGL.cmo webSockets.cmo keycode.cmo
MLINTFS= $(MLOBJS:.cmo=.mli)
COBJS= stubs$(OBJEXT)
OBJS=$(MLOBJS) $(COBJS)

JSON_OBJS=$(addprefix deriving_json/,deriving_Json_lexer.cmo deriving_Json.cmo)

include ../Makefile.conf
-include ../Makefile.local

ifneq "${WITH_DERIVING}" ""
PA_DERIVING=syntax/pa_deriving_Json.cmo
DERIVING_JSON=deriving_json.cma
ifeq "$(BEST)" "opt"
DERIVING_JSON += deriving_json.cmxs
ifeq "${NATDYNLINK}" "YES"
PA_DERIVING_NDL= syntax/pa_deriving_Json.cmx syntax/pa_deriving_Json.cmxs
endif
endif
endif

ifneq "${WITH_GRAPHICS}" ""
GRAPHICS_CMA=graphics/graphics.cma
endif

PA_JS= syntax/pa_js.cmo
ifeq "${BEST}" "opt"
ifeq "${NATDYNLINK}" "YES"
PA_JS_NDL= syntax/pa_js.cmx syntax/pa_js.cmxs
endif
endif

all: $(LIBNAME).cma \
	${PA_JS} ${PA_JS_NDL} \
	${PA_DERIVING} 	${PA_DERIVING_NDL} \
	${DERIVING_JSON} \
	${GRAPHICS_CMA}

$(LIBNAME).cma: $(OBJS)
	ocamlmklib -o $(LIBNAME) $(OBJS)

deriving_json.cma: $(JSON_OBJS)
	ocamlfind ocamlc -a -o $@ $^

deriving_json.cmxa: $(JSON_OBJS:.cmo=.cmx)
	ocamlfind ocamlopt -a -o $@ $^
deriving_json.cmxs: deriving_json.cmxa
	ocamlfind ocamlopt -shared -linkall -o $@ $^

syntax/pa_js.cmo: syntax/pa_js.ml
	ocamlfind ocamlc -package camlp4.extend,camlp4.quotations -syntax camlp4o -c $<

syntax/pa_js.cmx: syntax/pa_js.ml
	ocamlfind ocamlopt -package camlp4.extend,camlp4.quotations -syntax camlp4o -c $<

syntax/pa_js.cmxs: syntax/pa_js.cmx
	ocamlfind ocamlopt -shared -linkall -o $@ $<

syntax/pa_deriving_Json.cmo: syntax/pa_deriving_Json.ml syntax/pa_deriving_Json.cmi
	ocamlfind ocamlc -I syntax -package deriving.syntax.common,camlp4.quotations.o -syntax camlp4o -c $<

syntax/pa_deriving_Json.cmi: syntax/pa_deriving_Json.mli
	ocamlfind ocamlc -package deriving.syntax.common,camlp4.quotations.o -syntax camlp4o -c $<

syntax/pa_deriving_Json.cmx: syntax/pa_deriving_Json.ml
	ocamlfind ocamlopt -I syntax -package deriving.syntax.common,camlp4.quotations.o -syntax camlp4o -c $<

syntax/pa_deriving_Json.cmxs: syntax/pa_deriving_Json.cmx
	ocamlfind ocamlopt -I syntax -shared -linkall -o $@ $<

%.cmo: %.ml syntax/pa_js.cmo
	ocamlfind ocamlc -pp "camlp4o syntax/pa_js.cmo" -package lwt -c -g $<

sys_js.ml: sys_js.mlp
	sed -e "s|%%VERSION%%|`sed -e 1q ../VERSION`|" sys_js.mlp >sys_js.ml

%.cmi: %.mli
	ocamlfind ocamlc -package lwt -I deriving_json -c $<

%.ml: %.mll
	ocamllex $<

${JSON_OBJS}: %.cmo: %.ml ${PA_DERIVING}
	ocamlfind ocamlc -package deriving.syntax.common -syntax camlp4o -ppopt ${PA_DERIVING} -I deriving_json -c $<

${JSON_OBJS:.cmo=.cmx}: %.cmx: %.ml ${PA_DERIVING}
	ocamlfind ocamlopt -package deriving.syntax.common -syntax camlp4o -ppopt ${PA_DERIVING} -I deriving_json -c $<

graphics/graphics_js.cmo: graphics/graphics_js.ml graphics/graphics_js.cmi syntax/pa_js.cmo
	ocamlfind ocamlc -syntax camlp4o -package lwt,lwt.syntax,graphics -ppopt syntax/pa_js.cmo  -I ./ -I graphics -c graphics/graphics_js.ml -o $@

graphics/graphics_js.cmi: graphics/graphics_js.ml
	ocamlfind ocamlc -package lwt,graphics -I ./ graphics/graphics_js.mli -o $@

graphics/graphics.cma: graphics/graphics_js.cmo
	ocamlfind ocamlc -a -o $@ $^

%$(OBJEXT): %.c
	ocamlfind ocamlc -package lwt -c $<

stubs.c: $(MLOBJS:cmo=ml)
	(echo "#include <stdlib.h>"; \
	 echo "#include <stdio.h>"; \
	 echo "#define D(f) void f () { fprintf(stderr, \"Unimplemented Javascript primitive %s!\\\\n\", #f); exit(1); }"; \
	 (sed -n -e 's/.*external.*"\([^"%]*\)".*/D(\1)/p' $(MLOBJS:cmo=ml) | \
	  sort | uniq)) \
        > stubs.c

clean:
	rm -f *.cm[xioa] *.[ao] *.so *.cmx[sa]
	rm -f syntax/*.cm[xioa] syntax/*.[ao] syntax/*.so syntax/*.cmx[sa]
	rm -f deriving_json/*.cm[xioa] deriving_json/*.[ao] deriving_json/*.so
	rm -f deriving_json/deriving_Json_lexer.ml
	rm -f stubs.c
	rm -f sys_js.ml

depend: syntax/pa_js.cmo ${PA_DERIVING} sys_js.ml
	ocamldep -pp "camlp4o syntax/pa_js.cmo" *.ml *.mli > .depend
ifneq "${WITH_GRAPHICS}" ""
	ocamldep -pp "camlp4o syntax/pa_js.cmo" graphics/*.ml  >> .depend
	@# camlp4 3.12.0 fails on (module type of ...)
	ocamldep -I graphics graphics/graphics_js.mli  >> .depend
endif
ifneq "${WITH_DERIVING}" ""
	${MAKE} --no-print-directory deriving_json/deriving_Json_lexer.ml
	ls deriving_json/*.mli deriving_json/*.ml | \
	  grep -v deriving_Json_stdlib.mli | \
	  xargs ocamlfind ocamldep -I deriving_json -package deriving.syntax.common -syntax camlp4o -ppopt ${PA_DERIVING} >> .depend
	@# camlp4 3.12.0 fails on (module type of ...)
	ocamldep -I deriving_json deriving_json/deriving_Json_stdlib.mli  >> .depend
endif

include .depend

=== ocamlbuild/Makefile ===
OCAMLBUILD := ocamlbuild -use-ocamlfind

include ../Makefile.conf
-include ../Makefile.filelist

all:
	$(OCAMLBUILD) $(OCAMLBUILD_IMPL)

clean:
	$(OCAMLBUILD) -clean

=== runtime/Makefile ===
FILES= 	mlString.js ieee_754.js int64.js md5.js marshal.js \
	lexing.js parsing.js json.js bigarray.js unix.js \
	stdlib.js io.js fs.js jslib.js jslib_js_of_ocaml.js \
	internalMod.js gc.js

runtime.js: $(FILES)
	echo "//concat $(FILES)" > runtime.js
	for f in $(FILES) ; do \
		 echo "//# 1 \"$$f\"" >> runtime.js; \
	   cat $$f >> runtime.js; \
	done

clean:
	rm -f runtime.js

=== toplevel/Makefile ===

NAME=toplevel
OBJS=toplevel.cmo

all: $(NAME).js

include ../Makefile.conf
-include ../Makefile.local

ifeq ($(OCAML4),"YES")
OCAMLLIB=ocamlcommon.cma ocamlbytecomp.cma ocamltoplevel.cma
else
OCAMLLIB=toplevellib.cma
endif

COMPILER_LIBS=$(shell ocamlc -where)/compiler-libs

ifeq ($(METAOCAML),1)
BER=metalib.cma bertop.cmo
BER_MODULE=trx runcode
endif

OCPINDENT=$(shell ocamlfind query ocp-indent -format "-package %p.lib" 2> /dev/null)

ifneq ($(OCPINDENT),)
OPTCOMP_OPT=-ppopt -let -ppopt ocpindent=true
endif

COMP=../compiler/$(COMPILER)
JSFILES=../runtime/runtime.js ../runtime/weak.js ../runtime/toplevel.js ../runtime/graphics.js
OCAMLC=ocamlfind ocamlc -package lwt,optcomp -syntax camlp4o $(OCPINDENT) $(OPTCOMP_OPT) -ppopt "../lib/syntax/pa_js.cmo" \
	-I $(COMPILER_LIBS) -I ../compiler \
	-I ../lib -I ../lib/graphics
STDLIB= ../lib/$(LIBNAME).cma ../compiler/compiler.cma $(OCAMLLIB) $(BER) ../lib/graphics/graphics.cma
EXPUNGE=$(shell ocamlc -where)/expunge
# Removed gc and sys
STDLIB_MODULES=\
  arg \
  array \
  arrayLabels \
  buffer \
  callback \
  camlinternalLazy \
  camlinternalMod \
  camlinternalOO \
  char \
  complex \
  digest \
  filename \
  format \
  genlex \
  hashtbl \
  int32 \
  int64 \
  lazy \
  lexing \
  list \
  listLabels \
  map \
  marshal \
  moreLabels \
  nativeint \
  obj \
  oo \
  parsing \
  pervasives \
  printexc \
  printf \
  queue \
  random \
  scanf \
  set \
  sort \
  stack \
  stdLabels \
  stream \
  string \
  stringLabels \
  sys \
  weak \
	graphics \
	graphics_js \
	lwt \
	lwt_js \
	bigarray

JOO=js dom typed_array dom_html file dom_events firebug lwt_js sys_js regexp CSS url \
  form xmlHttpRequest event_arrows lwt_js_events json webGL webSockets keycode
JOO=js

PERVASIVES=$(STDLIB_MODULES) $(JOO) $(BER_MODULE) outcometree topdirs toploop

#toplevel.byte: $(OBJS:cmx=cmo) toplevel.cmo
#	ocamlfind ocamlc -linkall -g -package str -linkpkg toplevellib.cma -o $@.tmp $^

$(NAME).js: $(NAME).byte $(COMP) $(JSFILES) examples.ml
	$(COMP) -toplevel -noruntime $(JSFILES) $(NAME).byte \
	-I $(COMPILER_LIBS) \
	-I $(shell ocamlfind query lwt) \
	-I ./ -I ../lib/ -I ../lib/graphics \
	-ofs toplevel-fs.js $(OPTIONS) -file examples.ml

$(NAME).byte: $(OBJS) ../compiler/compiler.cma
	$(OCAMLC) -linkall -package findlib,graphics,lwt,bigarray $(OCPINDENT) -linkpkg -o $@.tmp $(STDLIB) $(OBJS)
	$(EXPUNGE) $@.tmp $@ $(PERVASIVES)
	rm -f $@.tmp

%.cmo: %.ml ../compiler/compiler.cma
	$(OCAMLC) -c $<

../compiler/compiler.cma:
	$(MAKE) -C ../compiler compiler.cma

server: server.ml
	ocamlfind ocamlc -linkpkg -package findlib,cohttp.lwt server.ml -o server

clean::
	rm -f *.cm[io] $(NAME).byte $(NAME).js

depend:
	ocamlfind ocamldep -syntax camlp4o -package optcomp -ppopt "../lib/syntax/pa_js.cmo" -I ../compiler *.ml *.mli > .depend

include .depend

=== examples/boulderdash/Makefile ===
OBJS=boulderdash.cmo
NAME=boulderdash
OPTIONS=-I ../../examples/boulderdash/ -file maps.txt:/ -file maps:/
include ../Makefile.common

=== examples/graph_viewer/Makefile ===
OBJS=scene.cmo viewer_common.cmo viewer_js.cmo
NAME=jsviewer
OPTIONS=-I ../../examples/graph_viewer -file scene.json:/

include ../Makefile.common
include .depend

=== examples/hyperbolic/Makefile ===
OBJS=hypertree.cmo
NAME=hypertree
OPTIONS=-I ../../examples/hyperbolic -file image_info.json:/ -file messages.json:/ -file tree.json:/

include ../Makefile.common

=== examples/webgl/Makefile ===
OBJS=webgldemo.cmo
NAME=webgldemo
OPTIONS=-I ../../examples/webgl -file monkey.model:/

include ../Makefile.common

=== debian/changelog ===
js-of-ocaml (2.2-2) unstable; urgency=medium

  * Fix FTBFS on bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Wed, 18 Jun 2014 12:59:58 +0200

js-of-ocaml (2.2-1) unstable; urgency=medium

  * New upstream release (Closes: #751693)
  * debian/patches:
    + Fix generation of compiler.cm*

 -- Stéphane Glondu <glondu@debian.org>  Tue, 17 Jun 2014 11:45:02 +0200

=== debian/control ===
Source: js-of-ocaml
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Build-Depends:
 debhelper (>= 8),
 dh-ocaml (>= 0.9~),
 ocaml-findlib (>= 1.4),
 liblwt-ocaml-dev (>= 2.4),
 libderiving-ocsigen-ocaml-dev (>= 0.6),
 camlp4,
 menhir,
 ocaml-nox (>= 4.01)
Standards-Version: 3.9.5
Homepage: http://ocsigen.org/js_of_ocaml
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/js-of-ocaml.git
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/js-of-ocaml.git

Package: js-of-ocaml
Architecture: any
Depends:
 libjs-of-ocaml-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bytecode to JavaScript compiler (compiler)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser. Its key features
 are the following:
  * the whole language, and most of the standard library are
    supported;
  * the generated code can be used with any web server and browser;
  * you can use a standard installation of OCaml to compile your
    programs. In particular, you do not have to recompile a library to
    use it with Js_of_ocaml. You just have to link your program with a
    specific library to interface with the browser APIs.
 .
 This package contains the compiler itself.

Package: libjs-of-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: libjs-of-ocaml (<< 1.4)
Replaces: libjs-of-ocaml (<< 1.4)
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bytecode to JavaScript compiler (development files)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser. Its key features
 are the following:
  * the whole language, and most of the standard library are
    supported;
  * the generated code can be used with any web server and browser;
  * you can use a standard installation of OCaml to compile your
    programs. In particular, you do not have to recompile a library to
    use it with Js_of_ocaml. You just have to link your program with a
    specific library to interface with the browser APIs.
 .
 This package contains development files needed to compile server-side
 (using regular OCaml compiler) and client-side (using Js_of_ocaml)
 programs.

Package: libjs-of-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: libjs-of-ocaml-dev (<< 1.4)
Replaces: libjs-of-ocaml-dev (<< 1.4)
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bytecode to JavaScript compiler (runtime)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser. Its key features
 are the following:
  * the whole language, and most of the standard library are
    supported;
  * the generated code can be used with any web server and browser;
  * you can use a standard installation of OCaml to compile your
    programs. In particular, you do not have to recompile a library to
    use it with Js_of_ocaml. You just have to link your program with a
    specific library to interface with the browser APIs.
 .
 This package contains runtime libraries that may be needed by
 server-side programs communicating with clients compiled with
 Js_of_ocaml using JSON.

Package: libjs-of-ocaml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: OCaml bytecode to JavaScript compiler (documentation)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser.
 .
 This package contains the API reference and examples.
